<template>
  <div class="flex flex-row">
    <info-cell>{{ event.id }}</info-cell>
    <info-cell>{{ event.name }}</info-cell>
    <info-cell>{{ event.date }}</info-cell>
    <info-cell>{{ event.description }}</info-cell>
    <info-cell>{{ event.lodge_id }}</info-cell>
    <div class="flex items-center">
      <router-link :to="{ name: 'EventMasons', params: { id: event.id } }">
        <view-button title="View massons of this event" />
      </router-link>
      <router-link :to="{ name: 'EditEvent', params: { id: event.id } }">
        <edit-button title="Edit event info" />
      </router-link>
      <remove-button @click="deleteEvent" title="Remove event from database" />
    </div>
  </div>
</template>

<script>
import InfoCell from '@/components/InfoCell.vue';
import EditButton from '@/components/EditButton.vue';
import ViewButton from '@/components/ViewButton.vue';
import RemoveButton from '@/components/RemoveButton.vue';
import { mapGetters, mapMutations } from 'vuex';
import axiosClient from '@/axiosClient';

export default {
  props: ['id'],
  components: {
    InfoCell,
    EditButton,
    ViewButton,
    RemoveButton,
  },
  methods: {
    ...mapMutations(['removeEvent']),
    deleteEvent() {
      axiosClient.delete(`/events/${this.id}`)
        .then(() => this.removeEvent(this.id))
    }
  },
  computed: {
    event() {
      return this.eventById(this.id)
    },
    ...mapGetters({
      eventById: "getEvent"
    })
  }
}
</script>